#!/bin/ash
# sqlite3-places-5a.sh # S'intègre à MRUF-lst. ## Adapté de sqlite3-places-5.sh
#
# (c) Christian L'Écuyer, Gatineau (Qc), Canada, Aug. 10 2017. GPL3
#  (Alias « musher0 » [forum Puppy].) # https://opensource.org/licenses/GPL-3.0
#### set -xe
SQLitePlaces () { sqlite3 places.sqlite 'select url,last_visit_date from moz_places'; }

CleanUp () { rm -f Last*;rm -f breve.lst;
i="";for i in 2 3 4;do rm -f breve$i.lst;done; } # We keep breve5.lst as ref. in case of a bug.

SkimURLs () { >Last_100.output2;
while read total;do Long="`expr ${#total} - 6`" # # This simple math operation removes the
	echo "${total:0:$Long}" >> Last_100.output2 # milliseconds in the time field.
done < Last_100.output

sort -t\| -nk 2 Last_100.output2 | awk -F'\|' '$1 !~ /seamonkey|firefox|mozilla|mozdev|sex|porn|lesarch|google/ { print $0 }' | sort -t '|' -nk 2 -u > Last_100.tri3
# Sort on time field, excluding some thematics we don't care about. You may edit these thematics.

while read url;do
	if [ "${url:0:11}" = "http://www." ];then echo "${url:11:${#url}}" >> breve.lst
	elif [ "${url:0:12}" = "https://www." ];then echo "${url:12:${#url}}" >> /breve.lst
	elif [ "${url:0:7}" = "http://" ];then echo "${url:7:${#url}}" >> breve.lst
	elif [ "${url:0:8}" = "https://" ];then echo "${url:8:${#url}}" >> breve.lst
	elif [ "${url:0:4}" = "www." ];then echo "${url:4:${#url}}" >> breve.lst
	else echo "${url}" >> breve.lst
	fi
done < Last_100.tri3

> breve2.lst;while read result;do Total1="${result%|*}"
	Total1="`echo ${Total1} | awk -F'\/' '{print $3"/"$4 }'`" # For the sake of brevity,
	# we show only the main sites, not the pages visited within them.
	 [ "${Total1:0:4}" = "www." ] && Total1="${Total1#*.}"
	Total2="`date -d @${result#*|} +'%x'`" # %R: This is a summary, we consider the date only.
	Mois="`date +'%m'`"
	Mois="`expr $Mois - 2`" # Change 2 to 3 if you want to view 3 months back.
	[ "${Mois}" -lt "10" ] && Mois="0$Mois" # This zero is needed from January to September.
	echo "$Total1 § $Total2" | awk -F'-' '$(NF-1) > '$Mois' { print $0 }' >> breve2.lst # We retrieve
	# the browsing history from 2 months (absolute) back. Or 3 months (possible at line 49).
done < Last_100.tri3

for i in 2 3 4;do j="`expr $i + 1`";uniq -u breve$i.lst > breve$j.lst;done
# We skim 3 times. # A plain sort would cancel the previous time sort. Uniq is much better in this case.
# Some entries are repeated, but they tell the user something because the time sort is respected.

BrwsR="`tail -1 /tmp/MZbrowser`" # v. 5a
[ "$BrwsR" = "firefox" -o "$BrwsR" = "seamonkey" ] && BrwsR=mozilla
> /tmp/Menu$BrwsR;while read entree;do if [ "$BrwsR" = "mozilla" ];then
		echo "cmd \"${entree%% *}\" \"defaultbrowser ${entree%% *}\"" >> /tmp/Menu$BrwsR
	else echo "cmd \"${entree%% *}\" \"$BrwsR ${entree%% *}\"" >> /tmp/Menu$BrwsR
	fi
done < breve5.lst
echo >> /tmp/Menu$BrwsR # v. 5a
CleanUp; }

#

echo > /tmp/MZurls # Action
ls -Algot /root/.*/*/*.default/places.sqlite | awk '{ print $NF }' > /tmp/MZplaces
while read place;do dir="`dirname $place`"
	echo "$dir" | awk -F'\/' '{ print $4 }' >> /tmp/MZbrowser # Name of browser
	cd "$dir"
	> breve.lst
	if [ -z $A ];then # If no positional parm., we work the whole URL field.
		SQLitePlaces | tail -n 130 | awk /http/ > Last_100.output
		SkimURLs
	fi
done < /tmp/MZplaces # set +xe
## 30 ##
